'---------------------------------------------------------------------------
'                                     USING ADO IN CODE STEP 1
'                                                Ron Kessler
'                                    Created 8/19/06 For VB 2005
'
'---------------------------------------------------------------------------

'This demonstrates the 7 steps to connect a datagrid control to an Access Database 
'We create all the objects in code instead of using the controls from the toolbox

'THERE ARE MANY WAYS TO DO THIS...I AM SHOWING YOU THE SIMPLEST WAY HERE


'--------------------------------------------------------------------------
'updated 10/13/08
'   10/13/08 Added my encrytion class to show how we can hide conn strings. Used in frmADO2
'                
Option Explicit On

'---import the ADO Namespaces
Imports System.data
Imports System.data.OleDb        'for Access  If you use SQL then Import System.Data.SqlClient


Public Class frmADO1

    Private Sub frmADO1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        LoadMyGrid()
    End Sub

    Private Sub LoadMyGrid()

        '---define all the pieces and parts IN THIS ORDER!!!
        Try
            ' STEP 1 :CONNECTION STRING 

            Dim connString As String
            connString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source= " & "..\..\customers.mdb"

            '   OPTIONAL WAY...TOO COOL
            ' ---Store this in App.config using the datasource wizard OR
            '   add it manually in the MyProject | Settings section.
            
            '---if you put conn string in app.config using the datasources wizard, access it this way:
            'Dim connString As String = My.Settings.customersConnectionString.ToString

            'STEP 2: CONNECTION OBJECT(uses the connString)
            Dim Conn As New OleDbConnection(connString)

            'STEP 3 MAKE SQL STRING(to define which records to get)

            Dim sqlString As String
            sqlString = "SELECT * from Customers ORDER BY LastName"

            'STEP 4 DATA ADAPTER (uses our SQL and Conn)
            Dim dataAdapter As New OleDbDataAdapter(sqlString, Conn)

            'STEP 5  DATASET(give the dataSet a name that relates to the data you want to display)
            Dim dataSet As New DataSet


            'STEP 6 FILL THE DATA ADAPTER
            dataAdapter.Fill(dataSet, "customers")


            'STEP 7 SET DATAGRID PROPERTIES
            DataGrid1.DataSource = dataSet
            DataGrid1.DataMember = "customers"

        Catch
            MsgBox("I could not read the database...", MsgBoxStyle.Critical, "System Message")
            Me.Close()
            End
        End Try

    End Sub


    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Application.Exit()
    End Sub

   
End Class
