'______________________________________________________________________________________________
'                                     USING ADO IN CODE STEP 2
'                                                Ron Kessler
'                                     Created 8/19/06 for VB 2005

'NOTES:
'This demonstrates how to update our DB using code. 

'Updated 10/23/08
'   10/23/08 Added ability to toggle the customer Id column on the grid using a new property.
'   10/13/08 Added conn string encryption. Added DoEncryption Class. Also, it encrypts each time
'                it runs (see form_load) so when installed on a host, credentials are hidden.
'               Changed Class-level variable tableName to a property.

'   4/27/07  Added a new class to hold ADO methods to make this more OOP in design!
'_____________________________________________________________________________________________

'After choosing Encryption from the File menu, open Ado in code.exe.config in the Debug folder 
'to see that the conn string IS encrypted. The original in app.config is not. So don't ship app.config!!!


Option Explicit On

'---import the usual suspects!
Imports System.Data
Imports System.Data.OleDb

Public Class frmADO2

#Region "Declares & Properties"
    Dim myDataSet As New DataSet
    Dim sqlStringShowAll As String = "SELECT * from Customers ORDER BY LastName"

    Private _tableName As String = String.Empty
    Private _showCustID As Boolean = False

    Private Property DB_TableName() As String
        Get
            Return _tableName
        End Get
        Set(ByVal value As String)
            _tableName = value
        End Set
    End Property

    Private Property ShowCustNumber() As Boolean
        Get
            Return _showCustID
        End Get
        Set(ByVal value As Boolean)
            _showCustID = value

        End Set
    End Property
#End Region

#Region "Form Load. Encrypt conn string and get records"
    Private Sub frmADO2_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        '---lets encrypt the conn string each time is runs....this would be used when you ship it to a customer.
        DoEncryption.EncryptOnHost()

        _tableName = "customers"

        ShowRecords(sqlStringShowAll)

    End Sub

    Private Sub ShowRecords(ByVal sqlString As String)

        '---fill data adapter. Then fill grid with our data
        ADOMethods.FillTheGrid(myDataSet, sqlString, DB_TableName)
        DataGrid1.DataSource = myDataSet
        DataGrid1.DataMember = DB_TableName

        Select Case ShowCustNumber
            Case True
                DataGrid1.Columns(0).Visible = True
            Case False
                DataGrid1.Columns(0).Visible = False
        End Select
    End Sub

#End Region

#Region "Save all changes to DB"
    Private Sub mnuFileSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileSave.Click


        ADOMethods.DoUpdate(myDataSet, sqlStringShowAll, DB_TableName)

    End Sub
#End Region

#Region "Select Statements"
    Private Sub SQL_Menu_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles LastFirstTelephoneToolStripMenuItem.Click, _
        SelectALLToolStripMenuItem.Click, LastFirstTeleFaxToolStripMenuItem.Click, _
        LastFirstAddressZipToolStripMenuItem.Click

        '---no saving unless they request all records
        If mnuFileSave.Enabled = True Then
            mnuFileSave.Enabled = False
        End If

        '---find out which menu item they clicked on the SQL menu
        Dim whichQuery As ToolStripMenuItem = CType(sender, ToolStripMenuItem)
        Dim sqlString As String = ""

        '---the names of the menu items were given by VB...look in properties of each menu item!
        'Each result from the query is saved to its own dataset table.
        Select Case whichQuery.Name

            Case "LastFirstTelephoneToolStripMenuItem"

                sqlString = "SELECT LastName as [Last Name], FirstName as [First Name]," & _
                    "Tele as [Telephone] FROM Customers ORDER BY LastName"
                _tableName = "sql1"

            Case "LastFirstAddressZipToolStripMenuItem"

                sqlString = "SELECT Lastname AS [Last Name], FirstName AS [First Name]," & _
                    "StreetAddress AS [Street Address], Zip AS [Zip Code] from Customers ORDER BY Tele"
                _tableName = "sql2"

            Case "LastFirstTeleFaxToolStripMenuItem"

                sqlString = "SELECT Customers.Lastname AS [Last Name], " & _
                    "Customers.FirstName AS [First Name], Tele AS [Telephone], " & _
                    "Fax AS [Fax #] from Customers ORDER BY Tele"
                _tableName = "sql3"

            Case "SelectALLToolStripMenuItem"
                sqlString = "SELECT * from Customers ORDER BY LastName"
                _tableName = "sql4"
                mnuFileSave.Enabled = True
        End Select

        ShowRecords(sqlString)

    End Sub
#End Region

    
#Region "Toggle Encryption"
    Private Sub EncryptConnToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EncryptConnToolStripMenuItem.Click

        '---remember, this is just for demonstration!
        DoEncryption.ConnStringEncryption()

    End Sub
#End Region

#Region "Toggle Show Customer Number"
    Private Sub mnuShowCustID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuShowCustID.Click

        ShowCustNumber = True
        ShowRecords(sqlStringShowAll)

    End Sub

    Private Sub mnuHideCustID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuHideCustID.Click
        ShowCustNumber = False
        ShowRecords(sqlStringShowAll)
    End Sub
#End Region

#Region "Quit"
    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        Application.Exit()
    End Sub
#End Region


End Class